package TCPIP_Programming;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.nio.charset.Charset;

import org.apache.mina.filter.codec.ProtocolCodecFilter;
import org.apache.mina.filter.codec.textline.TextLineCodecFactory;
import org.apache.mina.filter.logging.LoggingFilter;
import org.apache.mina.transport.socket.SocketAcceptor;
import org.apache.mina.transport.socket.nio.NioSocketAcceptor;

public class MINADualModeServer {
	// t|[gԍ
	private static final int ECHO_PORT = 1000;
	private static final int TIME_PORT = 9123;
	
	public static void main(String[] args) throws IOException { 
		// ANZv^p
		SocketAcceptor acceptor1 = new NioSocketAcceptor();
		acceptor1.getFilterChain().addLast("logger", new LoggingFilter()); // ftHg̃K[ǉ
		acceptor1.getFilterChain().addLast("codec",
				new ProtocolCodecFilter(
						new TextLineCodecFactory( Charset.forName("Windows-31J")))); // R[hϊǉ
		acceptor1.setReuseAddress( false );	// Kv΂trueɂ
		acceptor1.setHandler(new AnotherEchoProtocolHandler());
		// \PbgEAhXoChāAT[oJn
		acceptor1.bind(new InetSocketAddress(ECHO_PORT));
		System.out.println("MINA EchoT[oJn");
		// ANZv^p
		SocketAcceptor acceptor2 = new NioSocketAcceptor();
		acceptor2.getFilterChain().addLast("logger", new LoggingFilter()); // ftHg̃K[ǉ
		acceptor2.getFilterChain().addLast("codec",
				new ProtocolCodecFilter(
						new TextLineCodecFactory( Charset.forName("EUC_JP")))); // R[hϊǉ
		acceptor2.setReuseAddress( false );	// Kv΂trueɂ
		acceptor2.setHandler(new TimeProtocolHandler());
		// \PbgEAhXoChāAT[oJn
		acceptor2.bind(new InetSocketAddress(TIME_PORT));
		System.out.println("MINA TimeT[oJn");
		// 1ƂɃX[vbg
		for (;;) {
			System.out.println("Echo throughput, R: " + acceptor1.getStatistics().getReadBytesThroughput() + ", W: " + acceptor1.getStatistics().getWrittenBytesThroughput());
			System.out.println("Time throughput, R: " + acceptor2.getStatistics().getReadBytesThroughput() + ", W: " + acceptor2.getStatistics().getWrittenBytesThroughput());
			try {
				Thread.sleep(60 * 1000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}
}
