package TCPIP_Programming;

import java.io.*;
import java.nio.*;
import java.nio.channels.*;
import java.nio.channels.spi.*;
import java.nio.charset.*;
import java.net.*;
import java.util.*;

public class NonBlockingServer {
	static int port = 1000;			// ҂󂯃|[gԍ
    private Selector selector;			// ZN^
    int keysAdded = 0;					// tꂽL[̐
    SelectionKey acceptKey;				// ANZvg̃L[

    public static void main(String[] args) {
        NonBlockingServer nonblockingServer = new NonBlockingServer();
        nonblockingServer.start();
    }

    public void start() {
        try{       
            selector = SelectorProvider.provider().openSelector();
        	// ZN^̐
        	ServerSocketChannel channel = ServerSocketChannel.open();
        	// channel̃I[vĩNX̃RXgN^protectedƂȂĂj
        	channel.configureBlocking(false);
        	// 悸̃`lubNE[hɂ
        	String lh = "localhost";
        	// ł̓[vobNEAhXgp
        	// InetAddress lh = InetAddress.getLocalHost();
        	// 邢̓[JEzXgIPAhX擾
        	InetSocketAddress isa = new InetSocketAddress(lh, port);
        	// |[gƂƂɃ\PbgEAhX𐶐
        	channel.socket().bind(isa);
        	// ̃\PbgEAhXchannel̃\PbgɃoCh
            acceptKey = channel.register( selector, SelectionKey.OP_ACCEPT );
            // ̃`lANZvgL[̃ZN^ɓo^
            }
        	catch(UnknownHostException e){
        		System.out.println("[JEzXgs");
            	e.printStackTrace();
            	System.exit(-1);}
            catch(IOException e){
            	System.out.println("NIOException");
            	e.printStackTrace();
            	System.exit(-1);}

        // 烋[v
        try {
        	while (( keysAdded = acceptKey.selector().select()) > 0 ) {
        	// o͑̎s\ȑΉ`lL[Zbg
        		Set<SelectionKey> readyKeys = selector.selectedKeys();
        		// ̃ZN^̑IꂽL[Zbgꊇ擾Aׂ
                Iterator<SelectionKey> i = readyKeys.iterator();
                while (i.hasNext()) {
                    SelectionKey key = (SelectionKey)i.next();
                    // Iterator vfo
                    i.remove();
                    // ovf Iterator 폜
                    if (key.isAcceptable()) {
                        doAccept((ServerSocketChannel) key.channel());
                        // AcceptableȂServerSocketChannelɃLXgăNCAgڑ҂
                	} else if (key.isReadable()) {
                        SocketChannel channel = (SocketChannel)key.channel();
                        doRead(channel);
                        // ReadableȂSocketChannelɃLXgēǂݏoƃGR[obN
                	}
                }
        	}
        }catch(ClosedSelectorException e){
        	System.out.println("ZN^Ă");
        	e.printStackTrace();
        }catch(IOException e){
        	System.out.println("IOG[");
        	e.printStackTrace();
        }
    }
    
    // NCAgڑĂƂAccept
    private void doAccept(ServerSocketChannel serverChannel) {
        try {
            SocketChannel channel = serverChannel.accept();
            // ̃`l̃\Pbgɑ΂ڑ󂯕t
            Socket socket = channel.socket();
            SocketAddress client_address = socket.getRemoteSocketAddress();
            System.out.println("Start serving : " + client_address);
            channel.configureBlocking(false);
            // ̃`lubNE[hɐݒ
            channel.register(selector, SelectionKey.OP_READ);
            // ǂݏ̂߂ɂ̃ZN^ɓo^
        } catch (IOException ioe) {
            ioe.printStackTrace();
        }
    }

    // Read
    private void doRead(SocketChannel channel) {
        ByteBuffer buf = ByteBuffer.allocate(500);	// 500oCg̐VoCgEobt@p
        Charset charset = Charset.forName("Windows-31J");
        Socket socket = channel.socket();
        SocketAddress client_address = socket.getRemoteSocketAddress();
        int bytes = 0;
        try {
        	bytes = channel.read(buf);
            if (bytes < 0) {
            	// `lXg[̏IɒBꍇ -1Ԃ
                return;
            }
            if (bytes == 0){
            	// NCAgTCPڑnullԂ
            	System.out.println(client_address + " : Disconnected");
            	return;
            }
            // f[^
            buf.flip();
            boolean end = false;
            String message = charset.decode(buf).toString();
            if (message.startsWith("end") == true){
            	// NCAgZbVÎ߂"end"𑗂Ă
            	end = true;
            	System.out.print("Disconnection requested : " + client_address + " : " + message );
            }else{
            System.out.print("Received from : " + client_address + " : " + message);            
            message = "Server received (" + message.length() + " chraracters): " + message ;
            }
            // ^[~l[^tGR[obÑbZ[Wpӂ
            buf.clear();
            buf = charset.encode(message);	// wGR[fBOŃoCg
            bytes = channel.write(buf);
            // \PbgE`lɏ
            if (end){
            	// endŏ̃bZ[W͑Ԃセ̃`liڑjN[Y
            	try{
            		channel.close();
            	}catch (IOException ee){
            		System.out.println("`lEN[YIOG[");
            		ee.printStackTrace();
            	}
            }
        	return;
        } catch (IOException e) {
        	System.out.println("GR[EobNIOG[");
            e.printStackTrace();
            try {
            socket.close();
            }catch (IOException ee){}
        }
    }
}
