package TCPIP_Programming;

	/*
	 *  Licensed to the Apache Software Foundation (ASF) under one
	 *  or more contributor license agreements.  See the NOTICE file
	 *  distributed with this work for additional information
	 *  regarding copyright ownership.  The ASF licenses this file
	 *  to you under the Apache License, Version 2.0 (the
	 *  "License"); you may not use this file except in compliance
	 *  with the License.  You may obtain a copy of the License at
	 *
	 *    http://www.apache.org/licenses/LICENSE-2.0
	 *
	 *  Unless required by applicable law or agreed to in writing,
	 *  software distributed under the License is distributed on an
	 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
	 *  KIND, either express or implied.  See the License for the
	 *  specific language governing permissions and limitations
	 *  under the License.
	 *
	 */


	import java.net.InetSocketAddress;
	import org.apache.mina.transport.socket.SocketAcceptor;
	import org.apache.mina.transport.socket.nio.NioSocketAcceptor;

	/**
	 * (<b>Entry point</b>) Echo server
	 *
	 * @author The Apache MINA Project (dev@mina.apache.org)
	 * @version $Rev: 600461 $, $Date: 2007-12-03 10:55:52 +0100 (Mon, 03 Dec 2007) $
	 */
	public class SimpleMinaServer {
	    /** Choose your favorite port number. */
	    private static final int PORT = 1000;

	    public static void main(String[] args) throws Exception {
	        SocketAcceptor acceptor = new NioSocketAcceptor();
	        
	        // Bind
	        acceptor.setReuseAddress( true );
	        acceptor.setHandler(new EchoProtocolHandler());
	        acceptor.bind(new InetSocketAddress(PORT));

	        System.out.println("Listening on port " + PORT);
	        
	        for (;;) {
	            System.out.println("R: " + acceptor.getStatistics().getReadBytesThroughput() + ", W: " + acceptor.getStatistics().getWrittenBytesThroughput());
	            Thread.sleep(50000);
	        }
	    }
	}

