package TCPIP_Programming;

import java.util.Date;

import org.apache.mina.core.service.IoHandlerAdapter;
import org.apache.mina.core.session.IdleStatus;
import org.apache.mina.core.session.IoSession;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class TimeProtocolHandler extends IoHandlerAdapter{
    private final static Logger LOGGER = LoggerFactory.getLogger(EchoProtocolHandler.class);
    
    @Override
    public void sessionCreated(IoSession session) {
    	session.getConfig().setIdleTime(IdleStatus.BOTH_IDLE, 10);
    }

    @Override
    public void sessionClosed(IoSession session) throws Exception {
    	LOGGER.info("TIME_CLOSED");
    }

    @Override
    public void sessionOpened(IoSession session) throws Exception {
    	LOGGER.info("TIME_OPENED");
		Date date = new Date();
		session.write( "݂̎Ԃ́F" + date.toString());
		System.out.println("Time Message written...");
    }

    @Override
    public void sessionIdle(IoSession session, IdleStatus status) {
    	LOGGER.info("*** TIME_IDLE #" + session.getIdleCount(IdleStatus.BOTH_IDLE) + " ***");
		Date date = new Date();
		session.write( "݂̎Ԃ́F" + date.toString());
    }

    @Override
    public void exceptionCaught(IoSession session, Throwable cause) {
    	session.close(true);
    }

    @Override
    public void messageReceived(IoSession session, Object message)
            throws Exception {
    	// MIuWFNgStringƂēn
    	String rmes = (String)message;
    	// NCAgend𑗐MĂ
    	if( rmes.trim().startsWith("end") ) {
    		session.write("endM܂");
    		session.close(false);
    		return;
    	}
    	session.write("IƂend͂Ă");
    }

}
